/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.math.BigDecimal;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class Wallet {
  
  @SerializedName("currency")
  private String currency = null;
  @SerializedName("wallet_state")
  private String walletState = null;
  @SerializedName("block_state")
  private String blockState = null;
  @SerializedName("block_height")
  private BigDecimal blockHeight = null;
  @SerializedName("block_updated_at")
  private String blockUpdatedAt = null;

  /**
   * 화폐를 의미하는 영문 대문자 코드
   **/
  @ApiModelProperty(value = "화폐를 의미하는 영문 대문자 코드")
  public String getCurrency() {
    return currency;
  }
  public void setCurrency(String currency) {
    this.currency = currency;
  }

  /**
   * 입출금 상태 - working : 입출금 가능 - withdraw_only : 출금만 가능 - deposit_only : 입금만 가능 - paused : 입출금 중단 - unsupported : 입출금 미지원 
   **/
  @ApiModelProperty(value = "입출금 상태 - working : 입출금 가능 - withdraw_only : 출금만 가능 - deposit_only : 입금만 가능 - paused : 입출금 중단 - unsupported : 입출금 미지원 ")
  public String getWalletState() {
    return walletState;
  }
  public void setWalletState(String walletState) {
    this.walletState = walletState;
  }

  /**
   * 블록 상태 - normal : 정상 - delayed : 지연 - inactive : 비활성 (점검 등) 
   **/
  @ApiModelProperty(value = "블록 상태 - normal : 정상 - delayed : 지연 - inactive : 비활성 (점검 등) ")
  public String getBlockState() {
    return blockState;
  }
  public void setBlockState(String blockState) {
    this.blockState = blockState;
  }

  /**
   * 블록 높이
   **/
  @ApiModelProperty(value = "블록 높이")
  public BigDecimal getBlockHeight() {
    return blockHeight;
  }
  public void setBlockHeight(BigDecimal blockHeight) {
    this.blockHeight = blockHeight;
  }

  /**
   * 블록 갱신 시각
   **/
  @ApiModelProperty(value = "블록 갱신 시각")
  public String getBlockUpdatedAt() {
    return blockUpdatedAt;
  }
  public void setBlockUpdatedAt(String blockUpdatedAt) {
    this.blockUpdatedAt = blockUpdatedAt;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Wallet wallet = (Wallet) o;
    return (this.currency == null ? wallet.currency == null : this.currency.equals(wallet.currency)) &&
        (this.walletState == null ? wallet.walletState == null : this.walletState.equals(wallet.walletState)) &&
        (this.blockState == null ? wallet.blockState == null : this.blockState.equals(wallet.blockState)) &&
        (this.blockHeight == null ? wallet.blockHeight == null : this.blockHeight.equals(wallet.blockHeight)) &&
        (this.blockUpdatedAt == null ? wallet.blockUpdatedAt == null : this.blockUpdatedAt.equals(wallet.blockUpdatedAt));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.currency == null ? 0: this.currency.hashCode());
    result = 31 * result + (this.walletState == null ? 0: this.walletState.hashCode());
    result = 31 * result + (this.blockState == null ? 0: this.blockState.hashCode());
    result = 31 * result + (this.blockHeight == null ? 0: this.blockHeight.hashCode());
    result = 31 * result + (this.blockUpdatedAt == null ? 0: this.blockUpdatedAt.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class Wallet {\n");
    
    sb.append("  currency: ").append(currency).append("\n");
    sb.append("  walletState: ").append(walletState).append("\n");
    sb.append("  blockState: ").append(blockState).append("\n");
    sb.append("  blockHeight: ").append(blockHeight).append("\n");
    sb.append("  blockUpdatedAt: ").append(blockUpdatedAt).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
