# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' Deposit Class
#'
#' @field type 
#' @field uuid 
#' @field currency 
#' @field txid 
#' @field state 
#' @field created_at 
#' @field done_at 
#' @field amount 
#' @field fee 
#' @field transaction_type 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
Deposit <- R6::R6Class(
  'Deposit',
  public = list(
    `type` = NULL,
    `uuid` = NULL,
    `currency` = NULL,
    `txid` = NULL,
    `state` = NULL,
    `created_at` = NULL,
    `done_at` = NULL,
    `amount` = NULL,
    `fee` = NULL,
    `transaction_type` = NULL,
    initialize = function(`type`, `uuid`, `currency`, `txid`, `state`, `created_at`, `done_at`, `amount`, `fee`, `transaction_type`){
      if (!missing(`type`)) {
        stopifnot(is.character(`type`), length(`type`) == 1)
        self$`type` <- `type`
      }
      if (!missing(`uuid`)) {
        stopifnot(is.character(`uuid`), length(`uuid`) == 1)
        self$`uuid` <- `uuid`
      }
      if (!missing(`currency`)) {
        stopifnot(is.character(`currency`), length(`currency`) == 1)
        self$`currency` <- `currency`
      }
      if (!missing(`txid`)) {
        stopifnot(is.character(`txid`), length(`txid`) == 1)
        self$`txid` <- `txid`
      }
      if (!missing(`state`)) {
        stopifnot(is.character(`state`), length(`state`) == 1)
        self$`state` <- `state`
      }
      if (!missing(`created_at`)) {
        stopifnot(is.character(`created_at`), length(`created_at`) == 1)
        self$`created_at` <- `created_at`
      }
      if (!missing(`done_at`)) {
        stopifnot(is.character(`done_at`), length(`done_at`) == 1)
        self$`done_at` <- `done_at`
      }
      if (!missing(`amount`)) {
        stopifnot(is.character(`amount`), length(`amount`) == 1)
        self$`amount` <- `amount`
      }
      if (!missing(`fee`)) {
        stopifnot(is.character(`fee`), length(`fee`) == 1)
        self$`fee` <- `fee`
      }
      if (!missing(`transaction_type`)) {
        stopifnot(is.character(`transaction_type`), length(`transaction_type`) == 1)
        self$`transaction_type` <- `transaction_type`
      }
    },
    toJSON = function() {
      DepositObject <- list()
      if (!is.null(self$`type`)) {
        DepositObject[['type']] <- self$`type`
      }
      if (!is.null(self$`uuid`)) {
        DepositObject[['uuid']] <- self$`uuid`
      }
      if (!is.null(self$`currency`)) {
        DepositObject[['currency']] <- self$`currency`
      }
      if (!is.null(self$`txid`)) {
        DepositObject[['txid']] <- self$`txid`
      }
      if (!is.null(self$`state`)) {
        DepositObject[['state']] <- self$`state`
      }
      if (!is.null(self$`created_at`)) {
        DepositObject[['created_at']] <- self$`created_at`
      }
      if (!is.null(self$`done_at`)) {
        DepositObject[['done_at']] <- self$`done_at`
      }
      if (!is.null(self$`amount`)) {
        DepositObject[['amount']] <- self$`amount`
      }
      if (!is.null(self$`fee`)) {
        DepositObject[['fee']] <- self$`fee`
      }
      if (!is.null(self$`transaction_type`)) {
        DepositObject[['transaction_type']] <- self$`transaction_type`
      }

      DepositObject
    },
    fromJSON = function(DepositJson) {
      DepositObject <- jsonlite::fromJSON(DepositJson)
      if (!is.null(DepositObject$`type`)) {
        self$`type` <- DepositObject$`type`
      }
      if (!is.null(DepositObject$`uuid`)) {
        self$`uuid` <- DepositObject$`uuid`
      }
      if (!is.null(DepositObject$`currency`)) {
        self$`currency` <- DepositObject$`currency`
      }
      if (!is.null(DepositObject$`txid`)) {
        self$`txid` <- DepositObject$`txid`
      }
      if (!is.null(DepositObject$`state`)) {
        self$`state` <- DepositObject$`state`
      }
      if (!is.null(DepositObject$`created_at`)) {
        self$`created_at` <- DepositObject$`created_at`
      }
      if (!is.null(DepositObject$`done_at`)) {
        self$`done_at` <- DepositObject$`done_at`
      }
      if (!is.null(DepositObject$`amount`)) {
        self$`amount` <- DepositObject$`amount`
      }
      if (!is.null(DepositObject$`fee`)) {
        self$`fee` <- DepositObject$`fee`
      }
      if (!is.null(DepositObject$`transaction_type`)) {
        self$`transaction_type` <- DepositObject$`transaction_type`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "type": %s,
           "uuid": %s,
           "currency": %s,
           "txid": %s,
           "state": %s,
           "created_at": %s,
           "done_at": %s,
           "amount": %s,
           "fee": %s,
           "transaction_type": %s
        }',
        self$`type`,
        self$`uuid`,
        self$`currency`,
        self$`txid`,
        self$`state`,
        self$`created_at`,
        self$`done_at`,
        self$`amount`,
        self$`fee`,
        self$`transaction_type`
      )
    },
    fromJSONString = function(DepositJson) {
      DepositObject <- jsonlite::fromJSON(DepositJson)
      self$`type` <- DepositObject$`type`
      self$`uuid` <- DepositObject$`uuid`
      self$`currency` <- DepositObject$`currency`
      self$`txid` <- DepositObject$`txid`
      self$`state` <- DepositObject$`state`
      self$`created_at` <- DepositObject$`created_at`
      self$`done_at` <- DepositObject$`done_at`
      self$`amount` <- DepositObject$`amount`
      self$`fee` <- DepositObject$`fee`
      self$`transaction_type` <- DepositObject$`transaction_type`
    }
  )
)
