=begin
#Upbit Open API

### REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

OpenAPI spec version: 1.0.0
Contact: ujhin942@gmail.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.18

=end

require 'spec_helper'
require 'json'

# Unit tests for SwaggerClient::DepositApi
# Automatically generated by swagger-codegen (github.com/swagger-api/swagger-codegen)
# Please update as you see appropriate
describe 'DepositApi' do
  before do
    # run before each test
    @instance = SwaggerClient::DepositApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of DepositApi' do
    it 'should create an instance of DepositApi' do
      expect(@instance).to be_instance_of(SwaggerClient::DepositApi)
    end
  end

  # unit tests for deposit_coin_address
  # 개별 입금 주소 조회
  # ## 개별 입금 주소 조회  **NOTE**: 입금 주소 조회 요청 API 유의사항  입금 주소 생성 요청 이후 아직 발급되지 않은 상태일 경우 deposit_address가 null일 수 있습니다. 
  # @param currency Currency symbol 
  # @param [Hash] opts the optional parameters
  # @return [DepositCompleteResponse]
  describe 'deposit_coin_address test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for deposit_coin_addresses
  # 전체 입금 주소 조회
  # ## 내가 보유한 자산 리스트를 보여줍니다.  **NOTE**: 입금 주소 조회 요청 API 유의사항  입금 주소 생성 요청 이후 아직 발급되지 않은 상태일 경우 deposit_address가 null일 수 있습니다. 
  # @param [Hash] opts the optional parameters
  # @return [Object]
  describe 'deposit_coin_addresses test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for deposit_generate_coin_address
  # 입금 주소 생성 요청
  # 입금 주소 생성을 요청한다.  **NOTE**: 입금 주소 생성 요청 API 유의사항  입금 주소의 생성은 서버에서 비동기적으로 이뤄집니다. 비동기적 생성 특성상 요청과 동시에 입금 주소가 발급되지 않을 수 있습니다. 주소 발급 요청 시 결과로 Response1이 반환되며 주소 발급 완료 이전까지 계속 Response1이 반환됩니다. 주소가 발급된 이후부터는 새로운 주소가 발급되는 것이 아닌 이전에 발급된 주소가 Response2 형태로 반환됩니다. 정상적으로 주소가 생성되지 않는다면 일정 시간 이후 해당 API를 다시 호출해주시길 부탁드립니다. 
  # @param currency Currency 코드 
  # @param [Hash] opts the optional parameters
  # @return [DepositCompleteResponse]
  describe 'deposit_generate_coin_address test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for deposit_info
  # 개별 입금 조회
  # ## 개별 입금 조회 
  # @param [Hash] opts the optional parameters
  # @option opts [String] :uuid 입금 UUID 
  # @option opts [String] :txid 입금 TXID 
  # @option opts [String] :currency Currency 코드 
  # @return [Deposit]
  describe 'deposit_info test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for deposit_info_all
  # 입금 리스트 조회
  # ## 입금 리스트 조회 
  # @param [Hash] opts the optional parameters
  # @option opts [String] :currency Currency 코드 
  # @option opts [String] :state 출금 상태 - submitting : 처리 중 - submitted : 처리완료 - almost_accepted : 입금 대기 중 - rejected : 거절 - accepted : 승인됨 - processing : 처리 중 
  # @option opts [Array<String>] :uuids 입금 UUID의 목록 
  # @option opts [Array<String>] :txids 입금 TXID의 목록 
  # @option opts [Float] :limit 개수 제한 (default: 100, max: 100) 
  # @option opts [Float] :page 페이지 수, default: 1 
  # @option opts [String] :order_by 정렬 방식 - asc : 오름차순 - desc : 내림차순 (default) 
  # @return [Array<Deposit>]
  describe 'deposit_info_all test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
