# Rust API client for swagger

## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RustClientCodegen
For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

## Installation
Put the package under your project folder and add the following in import:
```
    "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeyApi* | [**a_pi_key_info**](docs/APIKeyApi.md#a_pi_key_info) | **Get** /api_keys | API 키 리스트 조회
*AccountApi* | [**account_info**](docs/AccountApi.md#account_info) | **Get** /accounts | 전체 계좌 조회
*AccountApi* | [**account_wallet**](docs/AccountApi.md#account_wallet) | **Get** /status/wallet | 입출금 현황
*CandleApi* | [**candle_days**](docs/CandleApi.md#candle_days) | **Get** /candles/days | 시세 캔들 조회 (일 단위)
*CandleApi* | [**candle_minutes**](docs/CandleApi.md#candle_minutes) | **Get** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*CandleApi* | [**candle_month**](docs/CandleApi.md#candle_month) | **Get** /candles/months | 시세 캔들 조회 (월 단위)
*CandleApi* | [**candle_weeks**](docs/CandleApi.md#candle_weeks) | **Get** /candles/weeks | 시세 캔들 조회 (주 단위)
*DepositApi* | [**deposit_coin_address**](docs/DepositApi.md#deposit_coin_address) | **Get** /deposits/coin_address | 개별 입금 주소 조회
*DepositApi* | [**deposit_coin_addresses**](docs/DepositApi.md#deposit_coin_addresses) | **Get** /deposits/coin_addresses | 전체 입금 주소 조회
*DepositApi* | [**deposit_generate_coin_address**](docs/DepositApi.md#deposit_generate_coin_address) | **Post** /deposits/generate_coin_address | 입금 주소 생성 요청
*DepositApi* | [**deposit_info**](docs/DepositApi.md#deposit_info) | **Get** /deposit | 개별 입금 조회
*DepositApi* | [**deposit_info_all**](docs/DepositApi.md#deposit_info_all) | **Get** /deposits | 입금 리스트 조회
*MarketApi* | [**market_info_all**](docs/MarketApi.md#market_info_all) | **Get** /market/all | 마켓 코드 조회
*OrderApi* | [**order_cancel**](docs/OrderApi.md#order_cancel) | **Delete** /order | 주문 취소 접수
*OrderApi* | [**order_chance**](docs/OrderApi.md#order_chance) | **Get** /orders/chance | 주문 가능 정보
*OrderApi* | [**order_info**](docs/OrderApi.md#order_info) | **Get** /order | 개별 주문 조회
*OrderApi* | [**order_info_all**](docs/OrderApi.md#order_info_all) | **Get** /orders | 주문 리스트 조회
*OrderApi* | [**order_new**](docs/OrderApi.md#order_new) | **Post** /orders | 주문하기
*OrderApi* | [**order_orderbook**](docs/OrderApi.md#order_orderbook) | **Get** /orderbook | 시세 호가 정보(Orderbook) 조회
*TradeApi* | [**trade_ticker**](docs/TradeApi.md#trade_ticker) | **Get** /ticker | 시세 Ticker 조회
*TradeApi* | [**trade_ticks**](docs/TradeApi.md#trade_ticks) | **Get** /trades/ticks | 시세 체결 조회
*WithdrawApi* | [**withdraw_chance**](docs/WithdrawApi.md#withdraw_chance) | **Get** /withdraws/chance | 출금 가능 정보
*WithdrawApi* | [**withdraw_coin**](docs/WithdrawApi.md#withdraw_coin) | **Post** /withdraws/coin | 코인 출금하기
*WithdrawApi* | [**withdraw_info**](docs/WithdrawApi.md#withdraw_info) | **Get** /withdraw | 개별 출금 조회
*WithdrawApi* | [**withdraw_info_all**](docs/WithdrawApi.md#withdraw_info_all) | **Get** /withdraws | 출금 리스트 조회
*WithdrawApi* | [**withdraw_krw**](docs/WithdrawApi.md#withdraw_krw) | **Post** /withdraws/krw | 원화 출금하기


## Documentation For Models

 - [Account](docs/Account.md)
 - [ApiKey](docs/ApiKey.md)
 - [Ask](docs/Ask.md)
 - [AskAccount](docs/AskAccount.md)
 - [Bid](docs/Bid.md)
 - [BidAccount](docs/BidAccount.md)
 - [CandleDate](docs/CandleDate.md)
 - [CandleDays](docs/CandleDays.md)
 - [CandleMinutes](docs/CandleMinutes.md)
 - [Currency](docs/Currency.md)
 - [Deposit](docs/Deposit.md)
 - [DepositCompleteResponse](docs/DepositCompleteResponse.md)
 - [DepositTransferResponse](docs/DepositTransferResponse.md)
 - [Error](docs/Error.md)
 - [ErrorInfo](docs/ErrorInfo.md)
 - [Market](docs/Market.md)
 - [MarketInfo](docs/MarketInfo.md)
 - [MemberLevel](docs/MemberLevel.md)
 - [NewOrder](docs/NewOrder.md)
 - [Order](docs/Order.md)
 - [OrderChance](docs/OrderChance.md)
 - [OrderInfo](docs/OrderInfo.md)
 - [Orderbook](docs/Orderbook.md)
 - [OrderbookUnit](docs/OrderbookUnit.md)
 - [Ticker](docs/Ticker.md)
 - [Trade](docs/Trade.md)
 - [TradeTicks](docs/TradeTicks.md)
 - [Wallet](docs/Wallet.md)
 - [Withdraw](docs/Withdraw.md)
 - [WithdrawChance](docs/WithdrawChance.md)
 - [WithdrawCoin](docs/WithdrawCoin.md)
 - [WithdrawLimit](docs/WithdrawLimit.md)


## Documentation For Authorization

## Bearer
- **Type**: API key 

Example
```
	auth := context.WithValue(context.TODO(), sw.ContextAPIKey, sw.APIKey{
		Key: "APIKEY",
		Prefix: "Bearer", // Omit if not necessary.
	})
    r, err := client.Service.Operation(auth, args)
```

## Author

ujhin942@gmail.com

